#include "graph.h"

#include <algorithm>
using namespace std;

GraphNode::GraphNode()
{
    m_neighbours = vector<GraphEdge>();
}

GraphNode::GraphNode(vector<GraphEdge> neighbours):m_neighbours(neighbours)
{
}

void GraphNode::addNeighbours(GraphNode* n,float f){
    GraphEdge edge = GraphEdge(n,f);
    addNeighbours(edge);
}

void GraphNode::addNeighbours(GraphEdge edge){
    m_neighbours.push_back(edge);
}

int GraphNode::getNbNeighbours(){
    return m_neighbours.size();
}

vector<GraphEdge> GraphNode::getNeighbours(){
    return m_neighbours;
}

void GraphNode::print(std::string prefix)
{
    cout << prefix << "Node_id : ";
    cout << prefix << m_testvalue << endl;
//    cout << prefix << "Neighbours list :" << endl;
    //prefix += "\t";
    //for_each (m_neighbours.begin(), m_neighbours.end(),[prefix](GraphEdge voisin) {
    //    voisin.getTarget()->print(prefix);
    //});
}

void GraphNode::setValue(int a){
    m_testvalue = a;
}

int GraphNode::getValue(){
    return m_testvalue;
}



GraphEdge::GraphEdge(GraphNode* gn,float v):m_target(gn),m_weight(v)
{}

GraphNode* GraphEdge::getTarget(){
    return m_target;
}

float GraphEdge::getWeight(){
    return m_weight;
}
