#ifndef GRAPH_H
#define GRAPH_H

#include<iostream>
#include <vector>

class GraphEdge;

class GraphNode
{
    std::vector<GraphEdge> m_neighbours;
    int m_testvalue;  //temp variable
public:
    GraphNode();
    GraphNode(std::vector<GraphEdge>);

    std::vector<GraphEdge> getNeighbours();
    void addNeighbours(GraphNode*,float);
    void addNeighbours(GraphEdge);
    int getNbNeighbours();
    virtual float heuristic(GraphNode*){return 1;};

    void setValue(int);
    int getValue();
    void print(std::string prefix);
};

class GraphEdge
{
    GraphNode* m_target;
    float m_weight;

public:
    GraphEdge(GraphNode*,float);
    GraphNode* getTarget();
    float getWeight();
};

#endif // GRAPH_H
